require 'gem_config'
require 'logger'

module LessonlyApi
  include GemConfig::Base

  with_configuration do
    has :logger,
        classes: ::Logger,
        default: ::Logger.new($stdout)

    has :root_url,
        classes: String,
        default: ENV['LESSONLY_ROOT_URL'] || 'https://api.lessonly.com/api/v1.1'

    has :domain,
        classes: String,
        default: ENV['LESSONLY_DOMAIN'] || ''

    has :api_key,
        classes: String,
        default: ENV['LESSONLY_API_KEY'] || ''

    has :webhook_handler
    has :webhook_authentication, classes: String
  end
end

require 'lessonly_api/version'
require 'lessonly_api/errors'

require 'lessonly_api/utils/client'
require 'lessonly_api/utils/custom_field_converter'
require 'lessonly_api/resource_type/base'
require 'lessonly_api/request'

require 'lessonly_api/users'
require 'lessonly_api/groups'
require 'lessonly_api/lessons'
require 'lessonly_api/paths'
require 'lessonly_api/assignments'
require 'lessonly_api/tags'

require 'lessonly_api/resource_type/users'
require 'lessonly_api/resource_type/user'
require 'lessonly_api/resource_type/groups'
require 'lessonly_api/resource_type/group'
require 'lessonly_api/resource_type/webhook'
require 'lessonly_api/resource_type/lessons'
require 'lessonly_api/resource_type/lesson'
require 'lessonly_api/resource_type/lesson_assignments_completed'
require 'lessonly_api/resource_type/links'
require 'lessonly_api/resource_type/paths'
require 'lessonly_api/resource_type/path'
require 'lessonly_api/resource_type/tags'
require 'lessonly_api/resource_type/tag'
require 'lessonly_api/resource_type/assignments'
require 'lessonly_api/resource_type/assignment'
require 'lessonly_api/resource_type/group_assignment'
require 'lessonly_api/resource_type/user_group'
require 'lessonly_api/resource_type/user_assignments'
require 'lessonly_api/resource_type/assignment'

