module LessonlyApi::Errors
  class Base < StandardError; end
  class ApiTimeoutError < Base; end
  class InvalidJson < Base; end

  class ApiError < Base
    attr_reader :body

    def initialize(body)
      @body = body
    end

    def message
      "#{self.class.name}: #{body}"
    end
  end

  class BadRequest < ApiError; end
  class Unauthorized < ApiError; end
  class Forbidden < ApiError; end
  class NotFound < ApiError; end
  class MethodNotAllowed < ApiError; end
  class NotAcceptable < ApiError; end
  class InternalServerError < ApiError; end
  class ServiceUnavailable < ApiError; end
end
