module LessonlyApi
  module ResourceType
    # Class represents API response as a Ruby object.
    class User < LessonlyApi::ResourceType::Base
      # @!method id
      # @return [Integer] ID of the user

      # @!method resource_type
      # @return [String] type of the resource

      # @!method type
      # @return [String] type of the resource

      # @!method ext_uid
      # @return [String] external ID of the user

      # @!method email
      # @return [String] an email of the user

      # @!method name
      # @return [String] a name of the user

      # @!method role
      # @return [String] a role of the user

      # @!method role_id
      # @return [Integer] ID of a user's role

      # @!method archived_at
      # @return [DateTime] timestamp of the user's archiving

      # @!method archived_by_user_id
      # @return [Inteher] ID of a user who archived the given user

      # @!method job_title
      # @return [String] title of the user's job

      # @!method business_unit
      # @return [String] business unit the user

      # @!method department
      # @return [String] name of the user's department

      # @!method location
      # @return [String] location of the user

      # @!method locale
      # @return [String] locale of the user

      # @!method hire_date
      # @return [Date] date of the user's hire

      # @!method manager_name
      # @return [String] name of the user's manager

      # @!method mobile_phone_number
      # @return [String] phone number of the user

      # @!method custom_user_field_data
      # @return [Array] array of hashes with custom fields

      # @!method groups
      # @return [ResourceType::UserGroup] the list of a user’s group memberships and groups the user is  managing

      fields(
        :id,
        :resource_type,
        :type,
        :ext_uid,
        :email,
        :name,
        :role,
        :role_id,
        {archived_at: :date_time},
        :archived_by_user_id,
        :job_title,
        :business_unit,
        :department,
        :location,
        :locale,
        {hire_date: :date},
        :manager_name,
        :mobile_phone_number,
        :custom_user_field_data,
        {groups: :user_group}
      )
    end
  end
end
