module LessonlyApi
  class Tags < Request
    class << self
      # Retrieve all tags
      # https://docs.lessonly.com/#list-tags
      #
      # @return [ResourceType::Tags] the response converted to a resource object
      def list
        raw_result = send_get('/tags')
        LessonlyApi::ResourceType::Tags.new(raw_result)
      end

      # Retrieve the tag's information
      # https://docs.lessonly.com/#show-tag-details
      #
      # @param id [Integer] ID of the tag
      # @return [ResourceType::Tag] the response converted to a resource object
      def show(id)
        raw_result = send_get("/tags/#{id}")
        ResourceType::Tag.new(raw_result)
      end
    end
  end
end
